<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier1 extends AbstractStructArrayBase
{
    /**
     * The InternalTransferSupplier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalTransferSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier1
     * @uses ArrayOfJP_InternalSupplier1::setInternalTransferSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalTransferSupplier
     */
    public function __construct(array $internalTransferSupplier = array())
    {
        $this
            ->setInternalTransferSupplier($internalTransferSupplier);
    }
    /**
     * Get InternalTransferSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalTransferSupplier()
    {
        return $this->InternalTransferSupplier;
    }
    /**
     * Set InternalTransferSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalTransferSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier1
     */
    public function setInternalTransferSupplier(array $internalTransferSupplier = array())
    {
        foreach ($internalTransferSupplier as $arrayOfJP_InternalSupplier1InternalTransferSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplier1InternalTransferSupplierItem instanceof \StructType\JP_InternalSupplier) {
                throw new \InvalidArgumentException(sprintf('The InternalTransferSupplier property can only contain items of \StructType\JP_InternalSupplier, "%s" given', is_object($arrayOfJP_InternalSupplier1InternalTransferSupplierItem) ? get_class($arrayOfJP_InternalSupplier1InternalTransferSupplierItem) : gettype($arrayOfJP_InternalSupplier1InternalTransferSupplierItem)), __LINE__);
            }
        }
        $this->InternalTransferSupplier = $internalTransferSupplier;
        return $this;
    }
    /**
     * Add item to InternalTransferSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier1
     */
    public function addToInternalTransferSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalTransferSupplier property can only contain items of \StructType\JP_InternalSupplier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InternalTransferSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalTransferSupplier
     */
    public function getAttributeName()
    {
        return 'InternalTransferSupplier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_InternalSupplier1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
